using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Generals;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IDebtRepository
    {
        Task<BaseResult> Add(DebtElastic Debt);
        Task<BaseResult> AddManyAsync(IEnumerable<DebtElastic> Debts);
        Task<SmartTableResult<DebtElastic>> Search(BoolQueryDescriptor<DebtElastic> query);

    }
    public class DebtRepository : IDebtRepository
    {
        private readonly ElasticIndex<DebtElastic> _dbContext;

        public DebtRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<DebtElastic>(settings.Value.ClusterUrl, "inventorydebt");
        }


        public async Task<SmartTableResult<DebtElastic>> Search(BoolQueryDescriptor<DebtElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(DebtElastic Debt)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Debt);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<DebtElastic> Debts)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Debts);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
